///
// This is a JAX-WS client skeleton put together to (hopefully) offer something that
// will be easy to adapt to other applications.
// *
// * Look for comment lines that begin with:
// * "//! Change - "
// * to know what lines in this code need to change to run against
// * another Web Service.
// 
// * We could have changed this code a bit so that the user would have less 
// * that he/she must manually edit but that would be at a cost of requiring 
// * that user understand the Java Class object and, just for our purposes, 
// * it did not seem worthwhile to do that.
// *
// Please direct questions to Nathan Goike or Jim Heath - thx
//

//! Change - The package name must agree with the package name where this 
//! Change - file is placed in AST
package simple;

//* These are generic imports; applicable to just about all JAX-WS clients
import java.net.URL; 

import javax.xml.namespace.QName; 
import javax.xml.ws.BindingProvider; 
import javax.xml.ws.Service; 
import javax.xml.ws.soap.SOAPBinding; 



public class MyClient {
//! Change - The package name must agree with the package name where this 
//! Change - file is placed in AST but use "/" as delimiter instead of "."
	private static final String PACKAGE_NAME = "simple";
	
//! Change - The value of the name attribute from 
//! Change - the <wsdl:service ... > element
	private static final String SERVICE_NAME = "LabService";

//! Change - The value of the "name" attribute from  
//! Change - the <wsdl:port ... > element
	private static final String PORT_NAME = "LabServicePort";

//! Change - The value of the "name" attribute from  
//! Change - the <wsdl:portType ... > element
//!	private static final String PORT_TYPE_NAME = "LabServicePortType";
	
	// * End of our special section ...
	// * ///////////////////////////////////////////////////////////////

	private static final String NAMESPACE = "http://" + PACKAGE_NAME;

	private static final QName QNAME_SERVICE = new QName(NAMESPACE,
			SERVICE_NAME);

	private static final QName QNAME_PORT = new QName(NAMESPACE,
			PORT_NAME);
	
//! Change - the URL to use to contact the Web Service
	private static final String 
               URL_ENDPOINT = "http://jim667:9082/SimpleWSRMService/LabService";

	public static void main(String[] args) {

		Service service = Service.create(QNAME_SERVICE);
// *
//! Change - Next real line is really like:
//! Change - <wsdl:portType.name> portTypeName = 
//! Change -           service.getPort(QNAME_PORT,<wsdl:portType.name>.class);
	      LabServicePortType portTypeName = service.getPort( 
	              QNAME_PORT, LabServicePortType.class); 

		BindingProvider bindingProvider = (BindingProvider) portTypeName;
		bindingProvider.getRequestContext().put(
				BindingProvider.ENDPOINT_ADDRESS_PROPERTY, URL_ENDPOINT);
		
//! Change - this line so that it is:
//! Change - String replyString = portTypeName.<operationName>(args);
//! Change - where you need to change <operationName> to the operation to invoke
//! Change - and "args" will be arguments to that operation 		
		String replyString = portTypeName.submit("Welcome to Web Services");
		System.out.println("reply = " + replyString);

	}
}
